/* Copyright 1989-93 GROUPE BULL -- See license conditions in file COPYRIGHT */
/***************\
*               *
*  KlO  WString *
*  DEFINITIONS  *
*               *
\***************/

#ifndef INCLUDE_Kl_WSTRING_H
#define INCLUDE_Kl_WSTRING_H

#ifdef WCHARS
#include "klwchars.h"

/* type */

typedef struct _KlWString {
    KlKLONE_HEADER;
    WREchar *string;
    unsigned int size;			/* the size in bytes */
    int length;				/* the logical size in wide chars */
}        *KlWString;

EXT KlType KlWStringType;

/* functions */

KlO KlString2WString();
KlO KlWString2List();
KlO KlList2WString();
KlO KlWString2String();
KlWString KlWStringCast();
KlString KlStringCast();
KlO KlWStringPosition();
KlO KlWStringSubseq();
KlO KlWStringNconc();

#define KlIsAWString(obj) ((obj)->type == KlWStringType)
#define KlMustBeWString(o, n) KlArgumentMustBe(o, n, KlWStringType)

/* useful macros */

#define KlWStringLength(s) ((s)->size)

#define KlMustBeWStringOrConvert(obj, pos) \
    if (!KlIsAWString(obj)) \
        if (KlIsAString(obj)) \
            obj = (KlWString) KlString2WString(obj); \
        else \
            KlBadArgument((obj), (pos), KlTypeCName(KlWStringType))
    
KlO KlWRegexec();
KlWString KlWRegsub();
KlWString KlWStringMatch();

EXT KlType KlWRegexpType;
    
#define KlIsAWRegexp(obj) ((obj)->type == KlWRegexpType)

#endif /* WCHARS */
#endif /* INCLUDE_Kl_WSTRING_H */
