#include <ctype.h>

#include "EXTERN.h"
#include "klone.h"
#ifdef SYSV_STRINGS
#include <string.h>
#else  /* !SYSV_STRINGS */
#include <strings.h>
#endif /* !SYSV_STRINGS */

#include "kl_atom.h"
#include "kl_string.h"
#include "kl_list.h"
#include "kl_coll.h"
#ifdef KLONE
#include "klko.h"
#endif

/* rename byacc main function to provide a wrapper to it */
#undef yyparse
#define yyparse KlyyparseRaw

#ifdef ISM
/* Take care to the foreign languages where dot character
 * is NOT the decimal separator
 */
#ifndef KOALA
#define KlParseReals(x)  extern double KlAtof (char *nptr);\
                       x = KlAtof(Klyytext)
extern double KlAtof();
#define KlParseReal(s, x) x = KlAtof(s)
#else /* KOALA, for tests */
#define KlParseReals(x) sscanf(Klyytext, "%lg", &x)
#define KlParseReal(s, x) sscanf(s, "%lg", &x)
#endif /* KOALA */
#else /* !ISM */
#define KlParseReals(x) sscanf(Klyytext, "%lg", &x)
#define KlParseReal(s, x) sscanf(s, "%lg", &x)
#endif /* ISM */

#define KlBT_BINSTREAMBEGIN 1		/* fixed */
#define KlBT_BINSTREAMEND 4		/* fixed */
#define KlBT_STRING 2

#ifdef IN_YACC_PARSER
extern char *Klyytext;
extern int Klyyleng;
#define yyleng Klyyleng
#define yytext Klyytext
#else /* !IN_YACC_PARSER */
extern int Klyy_buf_size;
extern char *Klyy_bufptr();
#endif /* !IN_YACC_PARSER */
