/* Copyright 1989-93 GROUPE BULL -- See license conditions in file COPYRIGHT */
/***************\
*               *
*  Wide Chars   *
*  DEFINITIONS  *
*               *
\***************/

/* these definitions define a WREchar type that can be any scalar type:
 * unsigned char, short, int, long ... 8/16/32 bits.
 * the normal ANSI use should be to define before including this file:
#define WREchar wchar_t
#define WREsize sizeof(wchar_t)
* which is done by defining WCHARS and USE_WCHAR_T
 */

#ifdef USE_WCHAR_T
#include <stdlib.h>
#if defined(sgi)
#include <wctype.h>
#endif /* sgi */
#define WREchar wchar_t
#define WREsize sizeof(wchar_t)
#endif /* USE_WCHAR_T */

/* this package should work for 8/16/32 bit chars (any scalar num) */
#ifndef WREsize
# ifdef WCHARS32
# define WREsize 4			/* size of char in bytes */
typedef unsigned int  WREchar;	/* the wide_char type (wchar_t) */
# else /* !WCHARS32 */
#  ifdef WCHARS
#  define WREsize 2			/* size of char in bytes */
typedef unsigned short  WREchar;	/* the wide_char type (wchar_t) */
#  endif /* !WCHARS */
# endif /* !WCHARS32 */

/* how is filled the high bytes of normal 8-bit chars? null or spaces? */
# ifndef WREasciimask
/* #define WREasciimask 0 */		/* null-filled */
# define WREasciimask 0x2000		/* space-filled, 16bit (unicode) */
/* #define WREasciimask 0x20202000 */	/* space-filled, 32bit */
# endif

#endif /* !WREsize */
