/*****************************************************************************\
*                                                                             *
* 			     WPPB parser routines                             *
*                                                                             *
\*****************************************************************************/

#ifdef WPPB
/****************************************************************** types */
typedef struct _KlWPPBContext {
    char *filename;
    unsigned char *buffer;
    struct _KlWPPBContext *old;
    KlO **dicts;
    int dictlimit;
    int version;
    char parse_disabled;
    jmp_buf jbuf;
#ifdef DEBUG
    int ndicts;
    int *dictsizes;
    unsigned char *last;
#endif DEBUG
} *KlWPPBContext;

EXT struct _KlWPPBContext KlWPPBCurrentContextData;
EXT KlWPPBContext KlWPPBCurrentContext INIT(&KlWPPBCurrentContextData);
#define KlWPPBCurrentContextDefDicts 3

/************************************************************** functions */
#if __STDC__
typedef unsigned char *(*KlWPPBReadFunction)(unsigned char *p, KlO *objp);
#else
typedef unsigned char *(*KlWPPBReadFunction)();
#endif

#ifdef DEBUG
unsigned char *KlWPPBParse();
#else
#define KlWPPBParse(p, objp) (((KlWPPBTable[*(p)]))((p)+1, (objp)))
#endif

/********************************************************** WPPB type IDs */
#define KlWPPBType_XType	 1
#define KlWPPBType_Raw		 5
#define KlWPPBType_Set		 2
#define KlWPPBType_Eval          3
#define KlWPPBType_WPPDInclude   4          
#define KlWPPBType_WPPDRef       0                      
#define KlWPPBType_WPPDRefL      6
#define KlWPPBType_Atom		 7
#define KlWPPBType_AtomL	 8
#define KlWPPBType_String	 9
#define KlWPPBType_StringL	10
#define KlWPPBType_List		11
#define KlWPPBType_ListM	12
#define KlWPPBType_ListML	13
#define KlWPPBType_IntS		14
#define KlWPPBType_IntP		15
#define KlWPPBType_IntN		16
#define KlWPPBType_IntU		17
#define KlWPPBType_Real		18
#define KlWPPBType_QuotedExpr	19
#define KlWPPBType_Expr		20
#define KlWPPBType_Nil		21
#define KlWPPBType_True		22
#define KlWPPBType_WPPDHere     23
#define KlWPPBType_Null         24
#define KlWPPBType_EOF          25
#define KlWPPBType_SetFunc		26

/**************************************************************** objects */
#ifndef WPPB_EXT
#define WPPB_EXT "p"
#endif
#ifndef WPPD_EXT
#define WPPD_EXT ".wld"
#endif
#ifndef WPPD_PACKAGE
#define WPPD_PACKAGE "wppd:"
#endif

EXT char *KlWPPB_EXT INIT(WPPB_EXT);
EXT char *KlWPPD_EXT INIT(WPPD_EXT);
EXT char *KlWPPD_PACKAGE INIT(WPPD_PACKAGE);
EXT int KlWPPB_EXT_len;
EXT int KlWPPD_EXT_len;
EXT int KlWPPB_EXTs_len;		/* max of the 2 preceding */
EXT int KlWPPD_PACKAGE_LEN;

EXT KlType KlWPPBReadListTypes[3];
EXT KlAtom KlWPPBReadQuotedExprSymbols[4];
EXT KlMethod KlWPPBReadQuotedExprEvals[4];

EXT int KlIsAWPPBFile INIT(0);
int KlLoadWPPBFile();
int KlWPPBParseBuffer();
#define KlWPPB_MAGIC 386928642		/* ^W^P^P^B */

					/* readtable */
EXT KlWPPBReadFunction *KlWPPBTable;
EXT char **KlWPPBTableNames;
EXT int KlWPPBTableSize;

#endif /* WPPB */
