/* Copyright 1989-93 GROUPE BULL -- See license conditions in file COPYRIGHT */
/******************************************************************************\
*                                                                              *
* 			      WIDE-CHAR REGEXPS                                *
*  a modification of the standard regexp package by Henry Spencer to work with *
* 			  wide chars, 16 or 32 bits                            *
*                                                                              *
\******************************************************************************/
/*
 * Definitions etc. for wregexp(3) routines. regexp for wide chars.
 * Symbols prefixed by WRE
 *
 * Caveat:  this is V8 regexp(3) [actually, a reimplementation thereof],
 * not the System V one.
 */

/* FILE DERIVED fROM Henry Spencer's distribution
 * By: Colas Nahaboo (Bull Research) October 1995, for Klone distrib
 * colas@sophia.inria.fr
 */

#ifdef DEBUG2
#ifndef DEBUG
#define DEBUG
#endif
#endif

#include "klwchars.h"

/* COLAS: no more #define NSUBEXP  10, dynamic now ==> 2^16 */
/* but the first 10 ones are stored the old way (smaller space) */
#define WRE_NSUBEXP_BUILTIN 10

typedef struct WREregexp {
    WREchar **startp;			/* the only one malloced */
    WREchar **endp;			/* points into previous */
    int nsubexp;		/* size of the startp and endp arrays */
    short *o_parnums;			/* stores extended numbers ( */
    short *c_parnums;			/* stores extended numbers ) */
    WREchar regstart;		/* Internal use only. */
    WREchar reganch;		/* Internal use only. */
    WREchar *regmust;		/* Internal use only. */
    int regmlen;		/* Internal use only. */
    WREchar program[1];	/* Unwarranted chumminess with compiler. */
} WREregexp;

extern WREregexp *WREregcomp();
extern int WREregexec();
/* extern void WREregsub(); /* COLAS: modification for Klone */
extern WREchar *WREregsub();

extern void WREregerror();

/* wide char version of string functions */
extern int WREstrlen();
extern WREchar *WREstrchr();
extern void WREstrcpy();


/* COLAS: following is the inclusion of file "regmagic.h",
 * and the renaming of MAGIC into WREREGMAGIC
 */
/*
 * The first WREchar of the regexp internal "program" is actually this magic
 * number; the start node begins in the second WREchar.
 */
#define	WREREGMAGIC	0xabcd
