/*****************************************************************************\
*                                                                             *
* 	       an exemple of a ses extension: simple calculator               *
*                                                                             *
\*****************************************************************************/
/* compile by:
   klone_cc ses_calc.c seslib.o -o ses_calc
 */
#include <stdio.h>
#include <errno.h>

#include "seslib.h"

SES_Connection sescon;

/*****************************************************************************\
* 				   WRAPPERS                                   *
\*****************************************************************************/

void
add(args)
    SES_Args args;
{
    int x = SES_ArgInt(args);
    int y = SES_ArgInt(args);

    SES_ReturnInt(args, x + y);
}

void
div(args)
    SES_Args args;
{
    double x = SES_ArgReal(args);
    double y = SES_ArgReal(args);

    if (y != 0)
	SES_ReturnReal(args, x / y);
    else
	SES_ReturnERROR(args, "(\"Division by 0\")");
}

/*****************************************************************************\
* 			     INIT, DECLARES, MAIN                             *
\*****************************************************************************/

main()
{
    sescon = SES_Init("calc");		/* init */

					/* export functions */
    SES_DeclareFunction(sescon, "calc:add", add, 2, SES_Int,
			SES_Int, SES_Int, 0);
    SES_DeclareFunction(sescon, "calc:div", div, 2, SES_Real,
			SES_Real, SES_Real, 0);
			
					/* mainloop */
    SES_MainLoop(sescon);
}
