/* ndbm.h  -  The include file for ndbm users.  */

/* Parameters to dbm_store for simple insertion or replacement. */
#define  DBM_INSERT  0
#define  DBM_REPLACE 1

/* The data and key structure.  This structure is defined for compatibility. */
typedef struct {
	char *dptr;
	int   dsize;
      } datum;

/* The file information header. This is good enough for most applications. */
typedef struct {int dummy[10];} DBM;

/* These are the routines (with some macros defining them!) */

extern DBM *dbm_open(const char *, int, int);
extern void dbm_close(DBM *);
extern datum dbm_fetch(DBM *, datum);
extern datum dbm_firstkey(DBM *);
extern datum dbm_nextkey(DBM *);
extern int dbm_delete(DBM *, datum);
extern int dbm_store(DBM *, datum, datum, int);
extern int dbm_dirfno (DBM *);
extern int dbm_pagfno (DBM *);

#define		 dbm_error(dbf)  0
#define		 dbm_clearerr(dbf)

