

/*      BEGIN CODE        */

#include <stdio.h>
#include <Kn/Knvas.h>
#include <Kn/KnvasP.h>
#include <X11/Shell.h>
#include <X11/StringDefs.h>


Widget toplevel, knvas;
KnTag slottag, greentag, greenbltag, greytag,
        bluetag;
XtAppContext context;
static String 
fallbacks[] = {
"vfpd.width: 500",
"vfpd.height: 300",
"*select1.callbackPolicy: CALLBACK_ON_PICK",
"*pixmapBuffering: True",
"*blue.foreground: blue",
"*green.foreground: green",
"*grey.foreground: grey",
"*varyCursor: false",
NULL
};


static void CPselect(Widget, XEvent *, char **, Cardinal *);
static void doubleClick(Widget, XEvent *, char **, Cardinal *);

static char translations[] = "\
 <Btn1Up>(2) : doubleClick()\n\
";
static XtActionsRec actions[] = {
	{ "doubleClick",doubleClick},
};


Pixel greencolor, greycolor;


static void
doubleClick(Widget wgt, XEvent *event, char **cstring, Cardinal *card)
{
   printf ("%s\n", "double click");
}

static void
CPselect(Widget wgt, XEvent *event, char **cstring, Cardinal *card)
{
   printf ("%s\n", "CPselect");

}


void
VfpdSelect(Widget w, XtPointer client, XtPointer call)
{
    KnvasWidget kw = (KnvasWidget)w;
   int i = client;
        KnTag tag;
        InteractorCallbackStruct *cs = (InteractorCallbackStruct *)call;
	
	printf ("%s%d\n", "VfpdSelect : client = ", i);

	printf("tag id = %d\n", cs->target->tid);
        tag = KnGetTag(w, cs->target);
        if (tag == bluetag)
                KnSetTag(knvas, cs->target, greentag);
        else
                KnSetTag(knvas, cs->target, bluetag);
	kw->knvas.grab = 0;
	       
	
}

int
main(int argc, char *argv[])
{
    KnO 		layer0;
    KnO 		group0;
    KnO 		obj;
    KnInteractor 	selectI,
       			dclickI, 
			mergeI;
    int			slotno,
       			i;
    char		buf[80];
    
#define CHASSIS_OFFSET 150

    toplevel = XtAppInitialize (&context, "Vfpd", 0, 0,
                               &argc, argv, fallbacks, 0, 0);
    XtAppAddActions (context, actions, XtNumber(actions));

    knvas = XtVaCreateManagedWidget ("essai",
				knvasWidgetClass, 
				toplevel,
                                NULL);

    layer0 = KnCreateLayer (knvas);
    group0 = KnCreateGroup (knvas, layer0, CHASSIS_OFFSET, 0);
    
    slottag    = KnCreateTag (knvas, "slot");
    bluetag    = KnCreateTag (knvas, "blue");
    greentag   = KnCreateTag (knvas, "green");
    greenbltag = KnCreateTag (knvas, "greenbl");
    
    XtVaGetValues (greentag, XmNforeground, &greencolor, 0);
    XtVaSetValues (greenbltag, XmNforeground, greencolor, 0);
    greytag = KnCreateTag (knvas, "grey");
    XtVaGetValues (greytag, XmNforeground, &greycolor, 0);
    
    dclickI = KnCreateInteractor (knvas, translations);
    selectI = KnCreateSelectInteractor (knvas, "select1");
    mergeI  = KnCreateInteractor (knvas, "");
    KnInteractorMerge (knvas, mergeI, selectI);
    KnInteractorMerge (knvas, mergeI, dclickI);


    for (slotno = 0; slotno <= 5; slotno++)
    {
            i = 28 * slotno;

            obj=KnCreateFRect (knvas, group0, 9+i, 7+0, 26, 226);
            KnSetTag (knvas, obj, slottag);

	    /* Why doesnt this work?                           */
            /* select callback works on first object selected, */
	    /* thereafter client data continues on 1st object  */
	    /* double click works                              */
	    KnSetInteractor (knvas, obj, mergeI);
   
            KnAddCallback (knvas, obj, XtNinteractorCallback, VfpdSelect, i);

    }
    
    XtRealizeWidget (toplevel);
    KnAppMainLoop (context);
}

/*      END CODE          */
