/* Copyright (c) 1995 by Groupe Bull.  All Rights Reserved */
/* $Id:$ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */


#include <stdio.h>
#include <Kn/Knvas.h>
#include <Kn/KnvasP.h>
#include <X11/Shell.h>
#include <X11/StringDefs.h>


Widget toplevel, knvas;
KnTag slottag, greentag, greenbltag, greytag,
        bluetag;
XtAppContext context;
static String 
fallbacks[] = {
"vfpd.width: 500",
"vfpd.height: 300",
"*select1.callbackPolicy: CALLBACK_ON_PICK",
"*pixmapBuffering: True",
"*blue.foreground: blue",
"*green.foreground: green",
"*grey.foreground: grey",
NULL
};

Pixel greencolor, greycolor;
void
VfpdSelect(Widget w, XtPointer client, XtPointer call)
{
        KnTag tag;
        InteractorCallbackStruct *cs = (InteractorCallbackStruct *)call;

	printf("tag id = %d\n", cs->target->tid);
        tag = KnGetTag(w, cs->target);
        if (tag == bluetag)
                KnSetTag(knvas, cs->target, greentag);
        else
                KnSetTag(knvas, cs->target, bluetag);
}

static void
blinkLed(void *unused1, XtIntervalId unused2)
{
        static Bool ledOn = TRUE;
        if (ledOn)
                XtVaSetValues(greenbltag, XmNforeground, greencolor, 0);
        else
                XtVaSetValues(greenbltag, XmNforeground, greycolor, 0);

        ledOn = !ledOn;
        KnvasUpdateLayers(knvas);
        XtAppAddTimeOut(context, 500, blinkLed, NULL);
}
int
main(int argc, char *argv[])
{
    KnO layer0, layer1, layer2, layer3;
    KnO obj;
    KnO group0, group1, group2, group3, group4;
    KnInteractor selectInt;
    int slotno, i;
    char buf[80];
#define CHASSIS_OFFSET 150

    toplevel = XtAppInitialize(&context, "Vfpd", 0, 0,
                               &argc, argv, fallbacks, 0, 0);
    knvas = 
        XtVaCreateManagedWidget("essai", knvasWidgetClass, toplevel,
                                NULL);
    layer0 = KnCreateLayer(knvas);
    group0 = KnCreateGroup(knvas, layer0, CHASSIS_OFFSET, 0);
    layer1 = KnCreateLayer(knvas);
    group1 = KnCreateGroup(knvas, layer1, CHASSIS_OFFSET, 0);
    layer2 = KnCreateLayer(knvas);
    group2 = KnCreateGroup(knvas, layer2, CHASSIS_OFFSET, 0);
    layer3 = KnCreateLayer(knvas);
    group3 = KnCreateGroup(knvas, layer3, CHASSIS_OFFSET, 0);
    slottag = KnCreateTag(knvas, "slot");
    bluetag = KnCreateTag(knvas, "blue");
    greentag = KnCreateTag(knvas, "green");
    greenbltag = KnCreateTag(knvas, "greenbl");
    XtVaGetValues(greentag, XmNforeground, &greencolor, 0);
    XtVaSetValues(greenbltag, XmNforeground, greencolor, 0);
    greytag = KnCreateTag(knvas, "grey");
    XtVaGetValues(greytag, XmNforeground, &greycolor, 0);
    selectInt=KnCreateSelectInteractor(knvas, "select1");
    for (slotno = 0; slotno <= 0; slotno++) {
            i = 26 * slotno;
            obj=KnCreateFRect(knvas, group1, 9+i, 7+0, 26, 226);
            KnSetTag(knvas, obj, slottag);

            group4=KnCreateGroup(knvas, group3, 9+i, 7+0);
            obj=KnCreateFRect(knvas, group4, 13, 22, 21-13+1, 12);
            KnSetTag(knvas, obj, greenbltag);
            KnSetInteractor(knvas, obj, selectInt);
            KnAddCallback(knvas, obj, XtNinteractorCallback, VfpdSelect, 0);
            obj=KnCreateFRect(knvas, group4, 13, 35, 21-13+1, 12);
            KnSetTag(knvas, obj, greentag);
            KnSetInteractor(knvas, obj, selectInt);
            KnAddCallback(knvas, obj, XtNinteractorCallback, VfpdSelect, 0);
    }
    XtAppAddTimeOut(context, 500, blinkLed, NULL);
    XtRealizeWidget(toplevel);
    KnAppMainLoop(context);
}
