/* Copyright (c) 1995 by Groupe Bull.  All Rights Reserved */
/* $Id:$ */


/* Copyright 1994 GROUPE BULL -- See license conditions in file COPYRIGHT */
static char rcsid[]="$Id: sample.c,v 1.6.1.8 94/11/09 21:25:47 leon Exp $";

#include <Kn/KnvasP.h>
#include <Kn/TagP.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>



void
KnDamage(Widget w, KnO kno)
{
    kno->flags &= ~KnCLEARED_FLAG;
    KlSend_clear(kno, w);
}


 void
EditProc(Widget w, XEvent *event, String *params, Cardinal *num);



char 
editBehavior[] = "\
 <ButtonPress>: KnEdit(%s)\n\
 <ButtonRelease>: KnEdit(%s)\n\
 <Motion>: KnEdit(%s)\n\
";  


static XtActionsRec
actions[] = {
    "KnEdit", EditProc,
};


KnInteractor edit;
KnLabel label;

static Widget tf = NULL;
static XmTextPosition pos = 0;




void
Motion(Widget tf, XtPointer client, XtPointer call)
{
    Widget w = (Widget)client;
    XmTextVerifyCallbackStruct *cs = (XmTextVerifyCallbackStruct *)call;

    pos = cs->newInsert;
    KnDamage(w, (KnO)label);
    KnvasUpdateDisplay(w);

    {
	/* Draw the prompt */

	TagObject tag;
	Dimension width, height;
	tag = (TagObject)KnGetTag(w, (KnO)label);
	width = XTextWidth(tag->tag.font, label->s, pos);
	height = tag->tag.font->ascent + tag->tag.font->descent;

	XDrawLine(XtDisplay(w), XtWindow(w), tag->tag.gc,
		  label->x+width, label->y, label->x+width, label->y + height);
    }


}

void
Modify(Widget tf, XtPointer client, XtPointer call)
{
    Widget w = (Widget)client;

    KnDamage(w, (KnO)label);
    
    XtVaGetValues(tf, XmNvalue, &(label->s), XmNcursorPosition, &pos, NULL);
    label->len = strlen(label->s);

    KnDamage(w, (KnO)label);
    KnvasUpdateDisplay(w);

    {
	/* Draw the prompt */

	TagObject tag;
	Dimension width, height;
	tag = (TagObject)KnGetTag(w, (KnO)label);
	width = XTextWidth(tag->tag.font, label->s, pos);
	height = tag->tag.font->ascent + tag->tag.font->descent;

	XDrawLine(XtDisplay(w), XtWindow(w), tag->tag.gc,
		  label->x+width, label->y, label->x+width, label->y + height);
    }
		  
	      
    
}

 void
EditProc(Widget w, XEvent *event, String *params, Cardinal *num)
{
    KnvasWidget cw = (KnvasWidget) w;
#define THIS cw->knvas
    Window win;
    XAnyEvent *e = (XAnyEvent *)event;
    TagObject tag = (TagObject) KnGetTag(w, (KnO)label);
    KnPosition x,y;

    if(NULL == THIS.target) return;
    THIS.dispatched = True;

    if(ButtonPress == e->type) {
	THIS.grab = (KnO)label;
	KnSelect(w, (KnO)label, True);
	
    }

    if(NULL == tf) {
	XmFontList flist;
	flist = XmFontListCreate(tag->tag.font, XmSTRING_DEFAULT_CHARSET);
	tf = XmCreateTextField(w, "tf", 0, 0);
	XtVaSetValues(tf,
		      XmNx, 0, XmNy, 100,
		      XmNwidth, 10000, XmNheight, 30,
		      XmNmarginWidth, 0, XmNmarginHeight, 0,
		      XmNfontList, flist,
		      0);
	XtManageChild(tf);
	XtUnmapWidget(tf); 
	XtAddCallback(tf, XmNvalueChangedCallback, Modify, w);
	XtAddCallback(tf, XmNmotionVerifyCallback, Motion, w);
    }
    

    e->window = XtWindow(tf);
    event->xbutton.x = event->xbutton.x - label->x;
    /*
    fprintf(stderr, "%d - ",  event->xbutton.x);
    fprintf(stderr, "%d %d\n", event->xbutton.x, label->x);
    */
    XtVaSetValues(tf, XmNvalue, label->s, XmNcursorPosition, pos, NULL);
    
    _XtTranslateEvent(tf, event);

    /* always update the cursor position */
    XtVaGetValues(tf, XmNcursorPosition, &pos, NULL);

    if(ButtonRelease == e->type) {
	THIS.grab = NULL;
    }
    
#undef THIS
}


int
main(int argc, char *argv[])
{
    XtAppContext context;
    Widget toplevel, knvas;
    KnO layer;
    KnInteractor move;


    toplevel =
	XtAppInitialize(&context, "Editor", 0, 0, &argc, argv, 0, 0, 0);
    
    XtAppAddActions(context, actions, XtNumber(actions));
    
    knvas = KnCreateKnvas(toplevel, "one", NULL, 0);

    layer = KnCreateLayer(knvas);
    label = (KnLabel)KnCreateLabel(knvas, layer, 0, 0,
				   "Hello world !!!! Hello world !!!! Hello world !!!! Hello world !!!! ");
    
    edit = KnCreateInteractor(knvas, editBehavior);
    move = KnCreateMoveInteractor(knvas, "move2");
    KnInteractorMerge(knvas, edit, move);
    KnSetInteractor(knvas, (KnO)label, edit);
    
    XtManageChild(knvas);
    XtRealizeWidget(toplevel);

    XtAppMainLoop(context);
}
