/* Copyright 1994 GROUPE BULL -- See license conditions in file COPYRIGHT */
static char rcsid[]="$Id: ex1.c,v 1.2 94/11/15 14:45:54 leon Exp $";

#include <stdio.h>
#include <math.h>
#include <strings.h>
#include <time.h>
#include <Kn/Knvas.h>
#include <X11/Shell.h>
#if (XtSpecificationRelease >= 5)
#include <X11/Xmu/Editres.h>
#endif


static String 
fallbacks[] = {
"*selectionLook: FANCY",
"*geometry: 900x675",
"*background:grey",
"*shadowThickness: 1",
"*KnResizeInteractor.button: 2",
"*essai.translations: #override\n <Key>i: KnvasZoom(2, 2)\n <Key>o: KnvasZoom(0.5, 0.5)",
"*visibleSelection: on",
"*pixmapBuffering: True",
"*green.foreground: green3",
"*green.shadowType: SHADOW_OUT",
"*red.foreground: red3",
"*red.lineWidth: 1",
"*red.capStyle: CapButt",
"*default.shadowType: SHADOW_OUT",
"*default.foreground: blue3",
"*default.background: yellow",
"*default.lineStyle: doubledash",
"*default.lineWidth: 2",
"*default.font: -adobe-helvetica-bold-o-normal--24-240-75-75-p-138-iso8859-1",
"*green3.foreground: yellow3",
"*green3.shadowType: SHADOW_OUT",
"*green4.foreground: green4",
NULL
};

/* fallbacks dead storage 
"*mi1.button: 1",
"*mi2.button: 2",
"*constraints: h",
"*default.symColors: team = purple",
*/

#define OSIZE 30
#define CSIZE 600
#define HSIZE 800  /* width of race track */
#define SSIZE 550  /* point at which bigger step size allowed */
#define JSIZE 830
#define MAX 8
#define MOVE 2

#define TIMER 1


static KnInteractor moveI,resizeI,selectI,fullI,mi;
static KnO circl,horse[5],boxx,pushme;
static KnTag green,red;
XtAppContext context;
Widget toplevel, knvas;
KnO kno,layer,group;
int cmove,rmove[5];
int step;
int winner;

static nframe = 0;

void
RESTART(Widget canvas, XtPointer client_data, XtPointer call_data)
{
    int i;
    KnO c;
    int seed;
    long rval;


    for(i=0;i<5;i++){
      c=horse[i];
      rmove[i]=OSIZE - c->x;
      KnTranslate(knvas,c,rmove[i],0);
    }

    step=5;
    seed=time(0);
    srand(seed);
    rval=rand();
    rmove[0]=rval%step+1;
    rval=rand();
    rmove[1]=rval%step+1;
    rval=rand();
    rmove[2]=rval%step+1;
    rval=rand();
    rmove[3]=rval%step+1;
    rval=rand();
    rmove[4]=rval%step+1;
    winner=0;            /* reset winner flag */
    nframe=0;
    KnvasUpdateDisplay(knvas); 
}

void
EXIT(Widget canvas, XtPointer client_data, XtPointer call_data)
{
  printf("\n");
  exit(1);
}
void
Anim(XtPointer client, XtIntervalId *id)
{
    int i;
    KnO c;
    long rval;
    
    
    for(i=0;i<5;i++){
      c=horse[i];
      if(c->x > SSIZE)step=7;
      if((c->x + OSIZE < HSIZE) && (c->x >=0)){
	if(rmove[i]>0){
	  KnTranslate(knvas,c,rmove[i],0);
	  rval=rand();
	  rmove[i]=rval%step+1;
	}
      }
    }
    /* at this point all horses have had their chance to move */


    /* check for any winners */
    for(i=0;i<5;i++){
      c=horse[i];
      if((c->x + OSIZE >= HSIZE) && (rmove[i]>0)){
	winner=1;  /* set to indicate a winner */
      }
    }
    
    if(winner>0 && rmove[0]+rmove[1]+rmove[2]+rmove[3]+rmove[4]>0 ){
      printf("[A[M");
      for(i=0;i<5;i++){
	c=horse[i];
	printf("  #%d:%3d",i+1,c->x+OSIZE);
	rmove[i]= 0;
      }
      printf("\n");
      printf("frames: %d\n", nframe);
      exit(0);
    }
    
    KnvasUpdateDisplay(knvas);
    XFlush(XtDisplay(knvas));

    XtAppAddTimeOut(context, TIMER, Anim, 0);
    nframe++;
}

int
main(int argc, char *argv[])
{
    int seed;
    long rval;

    seed=time(0);
    srand(seed);
    rval=rand();

    


    toplevel = XtAppInitialize(&context, "Races", 0, 0,
			       &argc, argv, fallbacks, 0, 0);

    knvas = 
	XtVaCreateManagedWidget("ex1", knvasWidgetClass, toplevel,
				NULL);
    layer = KnCreateLayer(knvas);

    /*
    moveI = KnCreateMoveInteractor(knvas, "move");
    resizeI = KnCreateResizeInteractor(knvas, "ri1");
    selectI = KnCreateSelectInteractor(knvas, "si1");
    fullI = KnCreateInteractor(knvas, "");
    KnInteractorMerge(knvas, fullI, moveI);
    KnInteractorMerge(knvas, fullI, resizeI);


    green = KnCreateTag(knvas, "green");
    red = KnCreateTag(knvas, "red");

    boxx=KnCreateFRect(knvas, layer, 100,520,30,30);
    KnSetTag(knvas, boxx, red);
    KnSetInteractor(knvas, boxx, moveI);
    KnAddCallback(knvas,boxx,XtNinteractorCallback,EXIT,0);

    pushme=KnCreateIcon(knvas, layer, "pushme", 220,  520);
    KnSetInteractor(knvas, pushme, moveI);
    KnAddCallback(knvas,pushme,XtNinteractorCallback,RESTART,0);
    
    kno = KnCreateLabel(knvas, layer, 50, 0, "Off To The Races........");
    KnSetInteractor(knvas, kno, moveI);
    KnAddCallback(knvas,kno,XtNinteractorCallback,RESTART,0);

    kno = KnCreateLine(knvas, layer,  20  , 10,  20  , 500);
    kno = KnCreateLine(knvas, layer, HSIZE, 10, HSIZE, 500);
    kno = KnCreateLine(knvas, layer, JSIZE, 10, JSIZE, 500);
    KnSetTag(knvas, kno, green);
    KnSetInteractor(knvas, kno, moveI);

    kno = KnCreateLabel(knvas, layer, JSIZE+30,  50, "1");
    kno = KnCreateLabel(knvas, layer, JSIZE+30, 150, "2");
    kno = KnCreateLabel(knvas, layer, JSIZE+30, 250, "3");
    kno = KnCreateLabel(knvas, layer, JSIZE+30, 350, "4");
    kno = KnCreateLabel(knvas, layer, JSIZE+30, 450, "5");
    */

    kno = KnCreateLine(knvas, layer,  20  ,100,  JSIZE ,100);
    kno = KnCreateLine(knvas, layer,  20  ,200,  JSIZE ,200);
    kno = KnCreateLine(knvas, layer,  20  ,300,  JSIZE ,300);
    kno = KnCreateLine(knvas, layer,  20  ,400,  JSIZE ,400);
    kno = KnCreateLine(knvas, layer,  20  ,500,  JSIZE ,500);

    
    horse[0]=KnCreateIcon(knvas, layer, "horse0", 20,  20);
    horse[1]=KnCreateIcon(knvas, layer, "horse1", 20, 120);
    horse[2]=KnCreateIcon(knvas, layer, "horse2", 20, 220);
    horse[3]=KnCreateIcon(knvas, layer, "horse3", 20, 320);
    horse[4]=KnCreateIcon(knvas, layer, "horse4", 20, 420);



    cmove=1;
    step=5;

    rval=rand();
    rmove[0]=rval%4+1;

    rval=rand();
    rmove[1]=rval%4+1;

    rval=rand();
    rmove[2]=rval%4+1;

    rval=rand();
    rmove[3]=rval%4+1;

    rval=rand();
    rmove[4]=rval%4+1;

    winner=0;            /* reset winner flag */

    printf("\n");
    printf("\n");
    printf("\n");

    XtRealizeWidget(toplevel);
    XtAppAddTimeOut(context, TIMER, Anim, 0);
    KnAppMainLoop(context);
}
