/* Copyright 1995 GROUPE BULL -- See license conditions in file COPYRIGHT */
/* $Id: cmdl.h,v 1.1 95/04/20 18:04:14 leon Exp $ */
#ifndef __CMDL_H
#define __CMDL_H


/* general command line arguments parsing utility */
/* this is greatly inspired from the Option mechanism available with Xt.
   Drawback from the Xt mechanism is that it requires to have a toplevel shell
   to call the XtGetApplicationResources. and so to open a connection to the X
   server etc...
   This requires nothing.
   */



#ifdef _cplusplus
extern "C" {
#endif




typedef enum _CmdlOptionType {
    CmdlOptionOneArg,
    CmdlOptionNoArg,
    CmdlOptionIsArg,
} CmdlOptionType;


typedef enum _CmdlOptionMode {
    CmdlOptionMandatory,
    CmdlOptionOptionnal,
} CmdlOptionMode;



typedef enum _CmdlOptionFlag {
    CmdlOptionNever 	= 0x0000,
    CmdlOptionUnknown 	= (1<<1),
    CmdlOptionNotFound 	= (1<<2),
    CmdlOptionBadArg 	= (1<<3),
    CmdlOptionAny	= 0xFFFF,
} CmdlOptionFlag;




typedef struct _CmdlOptionRec {
    char *name;
    CmdlOptionType type;
    CmdlOptionMode mode;
    char **value;
    char *info;
} CmdlOptionRec, *CmdlOption;


#define CmdlOptionNumber(array) (sizeof(array)/sizeof(CmdlOptionRec))


void
CmdlUsage(char *name, CmdlOptionRec *cmdlOptions, int number);


void 
CmdlScan(CmdlOptionRec *cmdlOptions, int number, int argc, char **argv,
	 CmdlOptionFlag error, CmdlOptionFlag warning);





#ifdef _cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif




#endif /* __CMDL_H */
/* DON'T ADD ANYTHING AFTER THIS #endif */
