/* Copyright (c) 1995 by Groupe Bull.  All Rights Reserved */
/* $Id: event.c,v 1.4 96/02/02 15:48:15 leon Exp $ */


#include <X11/Intrinsic.h>
#include <KlLib.h>


KlStructClass KlEventStruct;

XEvent last_event;


void
KlEventStructInitialize()
{

    KlEventStruct = KlStructClassMake("XEvent",
				    sizeof(XEvent),
				    10);

    KlDeclareStructClassSlot(KlEventStruct,
			     "type",
			     KlStructAccessorInt,
			     KlOffsetOf (XAnyEvent, type));

    KlDeclareStructClassSlot(KlEventStruct,
			     "window",
			     KlStructAccessorLong,
			     KlOffsetOf (XAnyEvent, window));

    KlDeclareStructClassSlot(KlEventStruct,
			     "time",
			     KlStructAccessorLong,
			     KlOffsetOf (XButtonEvent, time));
    
    KlDeclareStructClassSlot(KlEventStruct,
			     "x",
			     KlStructAccessorInt,
			     KlOffsetOf (XButtonEvent, x));

    KlDeclareStructClassSlot(KlEventStruct,
			     "y",
			     KlStructAccessorInt,
			     KlOffsetOf (XButtonEvent, y));
    
    KlDeclareStructClassSlot(KlEventStruct,
			     "xroot",
			     KlStructAccessorInt,
			     KlOffsetOf (XCrossingEvent, x_root));

    KlDeclareStructClassSlot(KlEventStruct,
			     "yroot",
			     KlStructAccessorInt,
			     KlOffsetOf (XButtonEvent, y_root));

    KlDeclareStructClassSlot(KlEventStruct,
			     "state",
			     KlStructAccessorInt,
			     KlOffsetOf (XKeyEvent, state));

    KlDeclareStructClassSlot(KlEventStruct,
			     "width",
			     KlStructAccessorInt,
			     KlOffsetOf (XConfigureEvent, width));

    KlDeclareStructClassSlot(KlEventStruct,
			     "height",
			     KlStructAccessorInt,
			     KlOffsetOf (XConfigureEvent, height));
    {
    static KlO kle = NULL;
    if(NULL == kle) {
	/* maybe this could be pushed at init time */
	kle = (KlO)KlIntern("*event*");
	KlIncRef(kle);
	KlSend_setq(kle, KlStructMake(KlEventStruct, &last_event));
    }
    }
    
}

void
KlSetLastEvent(XEvent *e)
{
    last_event = *e;
}
