/* Copyright 1995 GROUPE BULL -- See license conditions in file COPYRIGHT */
/* $Id: kl_classes.c,v 1.3 96/10/23 17:12:32 leon Exp $ */


#include "flags.h"
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <Xm/Xm.h>
#include "kl_widget.h"
#include "kl_motif.h"
#include "kl_custom.h"
#include "kl_classes.h"
#ifdef USE_CANVAS
#include "kl_knvas.h"
#endif /* USE_CANVAS */


KlWidget
PrivateClass (Int argc, KlO argv[])
{
    fprintf(stderr, "Hey, this is a private undocumented class !!\n");
    return (KlWidget)NIL;
};


static KlHash classes_table;

static KlWidgetClassRec classes[] = {
    {
	"XmArrowButton",
	KlArrowButton,
	"ArrowButton",
	NULL,
	0
    },
    {
	"XmBulletinBoard",
	KlBulletinBoard,
	"BulletinBoard",
	NULL,
	0
    },
    {
	"XmBulletinBoardDialog",
	KlBulletinBoardDialog,
	"BulletinBoardDialog",
	NULL,
	0
    },
    {
	"XmCascadeButton",
	KlCascadeButton,
	"CascadeButton",
	NULL,
	0
    },
    {
	"XmCommand",
	KlCommand,
	"Command",
	NULL,
	0
    },
    {
	"XmCommandDialog",
	KlCommandDialog,
	"CommandDialog",
	NULL,
	0
    },
    {
	"XmDialogShell",
	KlDialogShell,
	"DialogShell",
	NULL,
	0
    },
    {
	"XmDragIcon",
	KlDragIcon,
	"DragIcon",
	NULL,
	0
    },
    {
	"XmDrawingArea",
	KlDrawingArea,
	"DrawingArea",
	NULL,
	0
    },
    {
	"XmDrawnButton",
	KlDrawnButton,
	"DrawnButton",
	NULL,
	0
    },
    {
	"XmFileSelectionBox",
	KlFileSelectionBox,
	"FileSelectionBox",
	NULL,
	0
    },
    {
	"XmFileSelectionDialog",
	KlFileSelectionDialog,
	"FileSelectionDialog",
	NULL,
	0
    },
    {
	"XmForm",
	KlForm,
	"Form",
	NULL,
	0
    },
    {
	"XmFormDialog",
	KlFormDialog,
	"FormDialog",
	NULL,
	0
    },
    {
	"XmFrame",
	KlFrame,
	"Frame",
	NULL,
	0
    },
    {
	"XmLabel",
	KlLabel,
	"Label",
	NULL,
	0
    },
    {
	"XmList",
	KlItemList,
	"ItemList",
	NULL,
	0
    },
    {
	"XmScrolledList",
	KlScrolledList,
	"ScrolledList",
	NULL,
	0
    },
    {
	"XmMainWindow",
	KlMainWindow,
	"MainWindow",
	NULL,
	0
    },
    {
	"XmMenuShell",
	KlMenuShell,
	"MenuShell",
	NULL,
	0
    },
    {
	"XmMessageBox",
	KlMessageBox,
	"MessageBox",
	NULL,
	0
    },
    {
	"XmMessageDialog",
	KlMessageDialog,
	"MessageDialog",
	NULL,
	0
    },
    {
	"XmErrorDialog",
	KlErrorDialog,
	"ErrorDialog",
	NULL,
	0
    },
    {
	"XmInformationDialog",
	KlInformationDialog,
	"InformationDialog",
	NULL,
	0
    },
    {
	"XmQuestionDialog",
	KlQuestionDialog,
	"QuestionDialog",
	NULL,
	0
    },
    {
	"XmWarningDialog",
	KlWarningDialog,
	"WarningDialog",
	NULL,
	0
    },
    {
	"XmWorkingDialog",
	KlWorkingDialog,
	"WorkingDialog",
	NULL,
	0
    },
    {
	"XmTemplateDialog",
	KlTemplateDialog,
	"TemplateDialog",
	NULL,
	0
    },
    {
	"XmPanedWindow",
	KlPanedWindow,
	"PanedWindow",
	NULL,
	0
    },
    {
	"XmPushButton",
	KlPushButton,
	"PushButton",
	NULL,
	0
    },
    {
	"XmVPack",
	KlVerticalPacker,
	"VPack",
	NULL,
	0
    },
    {
	"XmHPack",
	KlHorizontalPacker,
	"HPack",
	NULL,
	0
    },
    {
	"XmRowColumn",
	KlRowColumn,
	"RowColumn",
	NULL,
	0
    },
    {
	"XmWorkArea",
	KlWorkArea,
	"WorkArea",
	NULL,
	0
    },
    {
	"XmRadioBox",
	KlRadioBox,
	"RadioBox",
	NULL,
	0
    },
    {
	"XmOptionMenu",
	KlOptionMenu,
	"OptionMenu",
	NULL,
	0
    },
    {
	"XmMenuBar",
	KlMenuBar,
	"MenuBar",
	NULL,
	0
    },
    {
	"XmPopupMenu",
	KlPopupMenu,
	"PopupMenu",
	NULL,
	0
    },
    {
	"XmPulldownMenu",
	KlPulldownMenu,
	"PulldownMenu",
	NULL,
	0
    },
    {
	"XmScale",
	KlScale,
	"Scale",
	NULL,
	0
    },
    {
	"XmScrollBar",
	KlScrollBar,
	"ScrollBar",
	NULL,
	0
    },
    {
	"XmScrolledWindow",
	KlScrolledWindow,
	"ScrolledWindow",
	NULL,
	0
    },
    {
	"XmSelectionBox",
	KlSelectionBox,
	"SelectionBox",
	NULL,
	0
    },
    {
	"XmSelectionDialog",
	KlSelectionDialog,
	"SelectionDialog",
	NULL,
	0
    },
    {
	"XmPromptDialog",
	KlPromptDialog,
	"PromptDialog",
	NULL,
	0
    },
    {
	"XmSeparator",
	KlSeparator,
	"Separator",
	NULL,
	0
    },
    {
	"XmScrolledText",
	KlScrolledText,
	"ScrolledText",
	NULL,
	0
    },
    {
	"XmText",
	KlText,
	"Text",
	NULL,
	0
    },
    {
	"XmTextField",
	KlTextField,
	"TextField",
	NULL,
	0
    },
    {
	"XmToggleButton",
	KlToggleButton,
	"ToggleButton",
	NULL,
	0
    },

    /* Custom classes */
#ifdef USE_TCP
    {
	"TcpConnection",
	KlTcpConnection,
	"TcpConnection",
	NULL,
	0
    },
#endif
#if defined(XmVERSION) && ( XmVERSION >= 2 )
    {
	"XmNotebook",
	KlNotebook,
	"Notebook",
	NULL,
	0
    },
    {
	"XmSpinBox",
	KlSpinBox,
	"SpinBox",
	NULL,
	0
    },
    {
	"XmComboBox",
	KlComboBox,
	"ComboBox",
	NULL,
	0
    },
    {
	"XmContainer",
	KlContainer,
	"Container",
	NULL,
	0
    },
    {
	"XmIconGadget",
	KlIconGadget,
	"IconGadget",
	NULL,
	0
    },
    {
	"XmCSText",
	KlCSText,
	"CSText",
	NULL,
	0
    },
#endif /* XmVERSION */

#ifdef USE_CANVAS
    {
	"Knvas",
	KlKnvas,
	"Knvas",
	NULL,
	0
    },
#endif /* USE_CANVAS */

    /* the following classes are private and should not be instanced */
    {
	"XmClipWindow",
	PrivateClass,
	"-- XmClipWindow --",
	NULL,
	0
    },
};




#ifdef USE_CANVAS
void
KlRegisterKnConstructors()
{
	KlDeclareSubr(KlLayer, "Layer", 1);
	KlDeclareSubr(KlLine, "Line", 5);
	KlDeclareSubr(KlRect, "Rect", 5);
	KlDeclareSubr(KlFRect, "Frect", 5);
	KlDeclareSubr(KlCircle, "Circle", 5);
	KlDeclareSubr(KlFCircle, "Fcircle", 5);
	KlDeclareSubr(KlCreateTag, "Tag", 2);
	KlDeclareSubr(KlIcon, "Icon", 4);
	KlDeclareSubr(KlSticker, "Sticker", 4);
	KlDeclareSubr(KlCreateAnchor, "Anchor", 4);
	KlDeclareSubr(KlCreateLink, "Link", 3);
	KlDeclareSubr(KlMoveInteractor, "MoveInteractor", 2);
	KlDeclareSubr(KlResizeInteractor, "ResizeInteractor", 2);
	KlDeclareSubr(KlSelectInteractor, "SelectInteractor", 2);
	
}

#endif /* USE_CANVAS */






extern KlWidget KlPushButtonNAry(int argc, KlO argv[]);

void
KlRegisterWidgetClasses()
{
    Cardinal n;
    KlList list;

    list = KlListNMake(0);
    classes_table = KlHashMake(list);
    KlIncRef(classes_table);
    classes_table->ref_counted &= ~(KlHashRefK | KlHashRefV);
    for(n = 0;  n < XtNumber(classes); n++) {
	KlDeclareSubr(classes[n].constructor, classes[n].name, NARY);
	KlHashPut(classes_table,
		  XrmStringToQuark(classes[n].class),
		  &(classes[n]));
    }
#ifdef USE_CANVAS
    KlRegisterKnConstructors();
#endif /* USE_CANVAS */
}    


KlWidgetClass
GetWidgetClass(Widget w)
{
    char *name;
    name = w->core.widget_class->core_class.class_name;
    return (KlWidgetClass) KlHashGet(classes_table,
				     XrmStringToQuark(name),
				     NULL);
}

KlWidgetClass
KlGetWidgetClass(KlWidget klw)
{
    KlArgumentMustBeValidWidget(klw, 0);
    return GetWidgetClass(klw->w);
}    


