/* Copyright (c) 1995 by Groupe Bull.  All Rights Reserved */
/* $Id: kl_tag.c,v 1.3 95/10/24 15:07:52 leon Exp $ */

/***
   NAME
     kl_tag
   PURPOSE
     
   NOTES
     
   HISTORY
     jml - Feb 7, 1995: Created.
***/




#include "kl_widget.h"
#include "kl_tag.h"

KlType KlTagType;


/* returns the Klone object associated to the tag.

 * returns: The  new KlTag */
KlTag
KlTagMake(KnTag tag)
{
    KlTag res;
    
    res =  (KlTag)KlOMake(KlTagType);
    res->tag = tag;
    res->pclass = NULL;
    res->p_list = NULL;
    return res;
}


void
KlTagImport()
{
    
}

KlO
KlTagEqual(KlTag t1, KlTag t2)
{
    if (t1->tag != t2->tag)
	return NIL;
    else
	return (KlO) t1;
}



KlO
KlTagExecute(KlTag kltag,  KlList list)
{
    KlArgumentMustBe(kltag, 0, KlTagType);
    return KlWidgetSetOrGet((KlWidget)kltag, list);
}

void
KlTagClassInitialize()
{
    KlList list;
    
    /* declare KlTag type */
    KlDeclareType(&KlTagType, "KlTag", sizeof(struct KlTagStruct));


    KlDeclarePlistSlot(KlTagType, KlTag, p_list);
    /* declare methods */
    KlDeclareMethod1(KlTagType, KlSelExecute, KlTagExecute); 
    KlDeclareMethod1(KlTagType, KlSelEqual, KlTagEqual); 

}

