/* Copyright 1995 GROUPE BULL -- See license conditions in file COPYRIGHT */
/* $Id: kl_widget.h,v 1.5 96/10/23 17:12:30 leon Exp $ */
#ifndef __KL_WIDGET_h
#define __KL_WIDGET_h

#include <X11/Intrinsic.h>
#include <KlLib.h>





typedef struct KlPseudoClassRec {
    KlO name;
    KlO initialize;
    KlO destroy;
    KlO setvalues;
    KlO getvalue;
    KlList resources;
    KlList callbacks;
} KlPseudoClassRec, *KlPseudoClass;




typedef struct KlWidgetRec {
    KlKLONE_HEADER;
    Widget w;			/* The Xt widget */
    KlPseudoClass pclass;	/* Widget's pseudo class or NULL */
    KlO p_list;			/* property list */
} KlWidgetRec, *KlWidget;

extern KlType KlWidgetType;
extern KlStructClass KlPseudoClassType;


extern KlAtom KlA_BAD_WIDGET;	/* BAD WIDGET exception */


#define KlArgumentMustBeWidget(o, n) KlArgumentMustBe(o, n, KlWidgetType)
#define KlIsAWidget(obj)  ((obj)->type == KlWidgetType)


#define KlArgumentMustBeValidWidget(o, n)\
KlArgumentMustBeWidget(o, n);\
if(o->w == NULL) { KlError1(KlA_BAD_WIDGET, o); }


extern KlO
KlWidgetSetOrGet(KlWidget klw, KlList list);

extern void KlWidgetInit();

KlWidget
KlWidgetMake(Widget w);


KlO
KlWidgetGetName(Widget w);


KlO
KlWidgetGetParent(Widget w);



KlO
KlWidgetGetClass(Widget w);


KlO
KlWidgetGetWindow(Widget w);


KlO
KlWidgetIsManaged(Widget w);


KlO
KlWidgetIsRealized(Widget w);


KlO
KlBindCallback(KlWidget klw, KlString name, KlList value);

KlO
KlUnbindCallback(KlWidget klw, KlString name, KlList value);

#endif /* __KL_WIDGET_h */
