/* Copyright (c) 1995 by Groupe Bull.  All Rights Reserved */
/* $Id: name.c,v 1.1 95/05/27 18:16:08 leon Exp $ */



#include <KlLib.h>
#include "kl_widget.h"
#include "funcs.h"


#define HasPList(o)\
((KlIsOfType(o, KlAtomType)) && (((KlAtom)o)->p_list))


static KlO
GetAlias(KlAtom klo)
{
    /* we assume the object is a subtype of KlAtom. */
    int i;
    KlList plist;
    if(klo->p_list) {
	plist = (KlList)klo->p_list;
	for(i = 0; i < plist->size; i += 2) {
	    if(KlIsOfType(plist->list[i], KlKeywordType) &&
	       !strcmp(":alias", ((KlKeyword)plist->list[i])->p_name)) {
		return plist->list[i+1];
	    }
	}
    }
    /* alias not found */
    return (KlO)klo;
}




/*
 * returns the first char ponting to the argument string.  * For keywords, it
 * skips the ':' first char.
 * The 'string' trait should have been tested before this.
 */
char *
GetNameString(KlO klo)
{
    KlO alias;
    if( HasPList(klo) && (alias = GetAlias((KlAtom)klo))) {
	return GetNameString(alias);
    }
    if(KlIsOfType(klo, KlKeywordType)) {
	/* selector's may be any Keyword subtype */
	KlKeyword keyword = (KlKeyword)klo;
	return( &(keyword->p_name[1]) ); /* skip first ':' */
    }
    else if(KlIsOfType(klo, KlAtomType)) {
	/* selector's may be any Atom subtype */
	KlAtom atom = (KlAtom)klo;
	return( atom->p_name );
    }
    else {
	/* must be a string */
	KlString str = (KlString)klo;
	return( str->string );
    }
}
